<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: dlib::shared_ptr&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacedlib.html">dlib</a></li><li class="navelem"><a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="#friends">Friends</a> &#124;
<a href="classdlib_1_1shared__ptr-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">dlib::shared_ptr&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1shared__ptr_1_1default__deleter.html">default_deleter</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structdlib_1_1shared__ptr_1_1deleter__template.html">deleter_template</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr class="memitem:a2bd33ec43ee9e2fa0746486e0b1888a5"><td class="memItemLeft" align="right" valign="top"><a id="a2bd33ec43ee9e2fa0746486e0b1888a5"></a>
typedef T&#160;</td><td class="memItemRight" valign="bottom"><b>element_type</b></td></tr>
<tr class="separator:a2bd33ec43ee9e2fa0746486e0b1888a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a103ffc9274d78be3b1ef97bae8c8494b"><td class="memTemplParams" colspan="2"><a id="a103ffc9274d78be3b1ef97bae8c8494b"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a103ffc9274d78be3b1ef97bae8c8494b"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b> (Y *p)</td></tr>
<tr class="separator:a103ffc9274d78be3b1ef97bae8c8494b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a283e75183ee0ed7f221cc15966be276a"><td class="memTemplParams" colspan="2"><a id="a283e75183ee0ed7f221cc15966be276a"></a>
template&lt;typename Y , typename D &gt; </td></tr>
<tr class="memitem:a283e75183ee0ed7f221cc15966be276a"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b> (Y *p, const D &amp;d)</td></tr>
<tr class="separator:a283e75183ee0ed7f221cc15966be276a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a75d7dc4895618bf8aafb5db65bc9a4e6"><td class="memItemLeft" align="right" valign="top"><a id="a75d7dc4895618bf8aafb5db65bc9a4e6"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>shared_ptr</b> (const <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a> &amp;r)</td></tr>
<tr class="separator:a75d7dc4895618bf8aafb5db65bc9a4e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a585b010dbe7c1c5f2376727eb5ec5424"><td class="memTemplParams" colspan="2"><a id="a585b010dbe7c1c5f2376727eb5ec5424"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a585b010dbe7c1c5f2376727eb5ec5424"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b> (const <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a>&lt; Y &gt; &amp;r, const <a class="el" href="structdlib_1_1shared__ptr__static__cast.html">shared_ptr_static_cast</a> &amp;)</td></tr>
<tr class="separator:a585b010dbe7c1c5f2376727eb5ec5424"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ef1a97bdabd57b1db896dbc62128ef0"><td class="memTemplParams" colspan="2"><a id="a2ef1a97bdabd57b1db896dbc62128ef0"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a2ef1a97bdabd57b1db896dbc62128ef0"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b> (const <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a>&lt; Y &gt; &amp;r, const <a class="el" href="structdlib_1_1shared__ptr__const__cast.html">shared_ptr_const_cast</a> &amp;)</td></tr>
<tr class="separator:a2ef1a97bdabd57b1db896dbc62128ef0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a72e04f7aaef8ed8c8a5e25dbb50c3db6"><td class="memTemplParams" colspan="2"><a id="a72e04f7aaef8ed8c8a5e25dbb50c3db6"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a72e04f7aaef8ed8c8a5e25dbb50c3db6"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b> (const <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a>&lt; Y &gt; &amp;r, const <a class="el" href="structdlib_1_1shared__ptr__dynamic__cast.html">shared_ptr_dynamic_cast</a> &amp;)</td></tr>
<tr class="separator:a72e04f7aaef8ed8c8a5e25dbb50c3db6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6cdaaf0c00ffc4a68459e54fe4601ee2"><td class="memTemplParams" colspan="2"><a id="a6cdaaf0c00ffc4a68459e54fe4601ee2"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a6cdaaf0c00ffc4a68459e54fe4601ee2"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b> (const <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a>&lt; Y &gt; &amp;r)</td></tr>
<tr class="separator:a6cdaaf0c00ffc4a68459e54fe4601ee2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5ff6d3363a7a1839f1f7d963c4097b13"><td class="memTemplParams" colspan="2"><a id="a5ff6d3363a7a1839f1f7d963c4097b13"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a5ff6d3363a7a1839f1f7d963c4097b13"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b> (const <a class="el" href="classdlib_1_1weak__ptr.html">weak_ptr</a>&lt; Y &gt; &amp;r)</td></tr>
<tr class="separator:a5ff6d3363a7a1839f1f7d963c4097b13"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d2cbdd8f8ca936024b30beb1415903f"><td class="memTemplParams" colspan="2"><a id="a4d2cbdd8f8ca936024b30beb1415903f"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a4d2cbdd8f8ca936024b30beb1415903f"><td class="memTemplItemLeft" align="right" valign="top">&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b> (std::auto_ptr&lt; Y &gt; &amp;r)</td></tr>
<tr class="separator:a4d2cbdd8f8ca936024b30beb1415903f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa44d9fb99624b625452d566821c47e3"><td class="memItemLeft" align="right" valign="top"><a id="afa44d9fb99624b625452d566821c47e3"></a>
<a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a> &amp;r)</td></tr>
<tr class="separator:afa44d9fb99624b625452d566821c47e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab1f6300e4ad6b0fd576dc0a374ed6e38"><td class="memTemplParams" colspan="2"><a id="ab1f6300e4ad6b0fd576dc0a374ed6e38"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:ab1f6300e4ad6b0fd576dc0a374ed6e38"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a> &amp;&#160;</td><td class="memTemplItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a>&lt; Y &gt; &amp;r)</td></tr>
<tr class="separator:ab1f6300e4ad6b0fd576dc0a374ed6e38"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3f2749c67c9172997d7fca2658ddd2f7"><td class="memTemplParams" colspan="2"><a id="a3f2749c67c9172997d7fca2658ddd2f7"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a3f2749c67c9172997d7fca2658ddd2f7"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a> &amp;&#160;</td><td class="memTemplItemRight" valign="bottom"><b>operator=</b> (std::auto_ptr&lt; Y &gt; &amp;r)</td></tr>
<tr class="separator:a3f2749c67c9172997d7fca2658ddd2f7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adc78d10a3196a68c325259db328071ce"><td class="memItemLeft" align="right" valign="top"><a id="adc78d10a3196a68c325259db328071ce"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>reset</b> ()</td></tr>
<tr class="separator:adc78d10a3196a68c325259db328071ce"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a05019a32b4e5ae464cfe4abdb7c18328"><td class="memTemplParams" colspan="2"><a id="a05019a32b4e5ae464cfe4abdb7c18328"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a05019a32b4e5ae464cfe4abdb7c18328"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><b>reset</b> (Y *p)</td></tr>
<tr class="separator:a05019a32b4e5ae464cfe4abdb7c18328"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa973be3f54042dedb8c2b27dede473a"><td class="memTemplParams" colspan="2"><a id="afa973be3f54042dedb8c2b27dede473a"></a>
template&lt;typename Y , typename D &gt; </td></tr>
<tr class="memitem:afa973be3f54042dedb8c2b27dede473a"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><b>reset</b> (Y *p, const D &amp;d)</td></tr>
<tr class="separator:afa973be3f54042dedb8c2b27dede473a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a87e5c6df2d09059a533e4b062f0ae9ec"><td class="memItemLeft" align="right" valign="top"><a id="a87e5c6df2d09059a533e4b062f0ae9ec"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator*</b> () const</td></tr>
<tr class="separator:a87e5c6df2d09059a533e4b062f0ae9ec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa466a70aa3fcc861d3fb30b54b439823"><td class="memItemLeft" align="right" valign="top"><a id="aa466a70aa3fcc861d3fb30b54b439823"></a>
T *&#160;</td><td class="memItemRight" valign="bottom"><b>operator-&gt;</b> () const</td></tr>
<tr class="separator:aa466a70aa3fcc861d3fb30b54b439823"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a831f6ebd23d0d702d48cc9a031edf6f6"><td class="memItemLeft" align="right" valign="top"><a id="a831f6ebd23d0d702d48cc9a031edf6f6"></a>
T *&#160;</td><td class="memItemRight" valign="bottom"><b>get</b> () const</td></tr>
<tr class="separator:a831f6ebd23d0d702d48cc9a031edf6f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b4a27f835795a5f0729c61c635d147b"><td class="memItemLeft" align="right" valign="top"><a id="a1b4a27f835795a5f0729c61c635d147b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>unique</b> () const</td></tr>
<tr class="separator:a1b4a27f835795a5f0729c61c635d147b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1e7b835f757a1e2504df808892d294f9"><td class="memItemLeft" align="right" valign="top"><a id="a1e7b835f757a1e2504df808892d294f9"></a>
long&#160;</td><td class="memItemRight" valign="bottom"><b>use_count</b> () const</td></tr>
<tr class="separator:a1e7b835f757a1e2504df808892d294f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af8b8bc006b5cd46ae2fe76051cda8d6f"><td class="memItemLeft" align="right" valign="top"><a id="af8b8bc006b5cd46ae2fe76051cda8d6f"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>operator bool</b> () const</td></tr>
<tr class="separator:af8b8bc006b5cd46ae2fe76051cda8d6f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa4ce8ea49a0a4096842c72a0510a914"><td class="memItemLeft" align="right" valign="top"><a id="afa4ce8ea49a0a4096842c72a0510a914"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>swap</b> (<a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a> &amp;b)</td></tr>
<tr class="separator:afa4ce8ea49a0a4096842c72a0510a914"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5f3150ed9e64d0c68d40a8acf47656f0"><td class="memTemplParams" colspan="2"><a id="a5f3150ed9e64d0c68d40a8acf47656f0"></a>
template&lt;typename D &gt; </td></tr>
<tr class="memitem:a5f3150ed9e64d0c68d40a8acf47656f0"><td class="memTemplItemLeft" align="right" valign="top">D *&#160;</td><td class="memTemplItemRight" valign="bottom"><b>_get_deleter</b> () const</td></tr>
<tr class="separator:a5f3150ed9e64d0c68d40a8acf47656f0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae767188822c5880379fe6739068964e0"><td class="memTemplParams" colspan="2"><a id="ae767188822c5880379fe6739068964e0"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:ae767188822c5880379fe6739068964e0"><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><b>_private_less</b> (const <a class="el" href="classdlib_1_1shared__ptr.html">shared_ptr</a>&lt; Y &gt; &amp;rhs) const</td></tr>
<tr class="separator:ae767188822c5880379fe6739068964e0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a5f7fca600160dd1cd104600430276f61"><td class="memItemLeft" align="right" valign="top"><a id="a5f7fca600160dd1cd104600430276f61"></a>
T *&#160;</td><td class="memItemRight" valign="bottom"><b>data</b></td></tr>
<tr class="separator:a5f7fca600160dd1cd104600430276f61"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a302bf3d5f5fedb78d2fe2824ab26571f"><td class="memItemLeft" align="right" valign="top"><a id="a302bf3d5f5fedb78d2fe2824ab26571f"></a>
<a class="el" href="structdlib_1_1shared__ptr__node.html">shared_ptr_node</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>shared_node</b></td></tr>
<tr class="separator:a302bf3d5f5fedb78d2fe2824ab26571f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="friends"></a>
Friends</h2></td></tr>
<tr class="memitem:ab2104fa6e839672da3c30400e8325e52"><td class="memTemplParams" colspan="2"><a id="ab2104fa6e839672da3c30400e8325e52"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:ab2104fa6e839672da3c30400e8325e52"><td class="memTemplItemLeft" align="right" valign="top">class&#160;</td><td class="memTemplItemRight" valign="bottom"><b>shared_ptr</b></td></tr>
<tr class="separator:ab2104fa6e839672da3c30400e8325e52"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a27df6e2a1650d985bdeda33f0303c83f"><td class="memTemplParams" colspan="2"><a id="a27df6e2a1650d985bdeda33f0303c83f"></a>
template&lt;typename Y &gt; </td></tr>
<tr class="memitem:a27df6e2a1650d985bdeda33f0303c83f"><td class="memTemplItemLeft" align="right" valign="top">class&#160;</td><td class="memTemplItemRight" valign="bottom"><b>weak_ptr</b></td></tr>
<tr class="separator:a27df6e2a1650d985bdeda33f0303c83f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="shared__ptr_8h_source.html">shared_ptr.h</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
